scriptname sslRapeSpellEffect extends ActiveMagicEffect  

; Our script doing the heavy lifting
sslRapeSpell [] property RapeSpellArray auto
sslRapeSpell property PlayerRapeSpell auto
Sound Property SexLabRSPush auto
Keyword Property ArmorCuirass auto
Keyword Property ClothingBody auto

bool reported = false
sslRapeSpell RapeSpell = None

; Spell effect has started
event OnEffectStart(actor target, actor caster)
	if (caster != Game.getPlayer())
		int i = 0
		RapeSpell = None
		while (i < RapeSpellArray.Length)
			if (RapeSpellArray[i].getActorRef() == None)
				RapeSpell = RapeSpellArray[i]
				(RapeSpell as ReferenceAlias).forceRefTo(caster)
				i = RapeSpellArray.Length
			endIf
			i += 1
		endWhile
		if (RapeSpell == None)
			showMessage("Raper full.. "+caster.getLeveledActorBase().getName()+" should give up")
			return
		endIf
	else
		RapeSpell = PlayerRapeSpell
		(RapeSpell as ReferenceAlias).forceRefTo(caster)
	endIf

	bool friendly = (target.getRelationshipRank(caster) > 0)
	if (target.isWeaponDrawn() && target.isHostileToActor(caster))
		return
	endIf
	RapeSpell.storeArousal(target)
	SexLabRSPush.play(target)
	if (target != Game.getPlayer())
		caster.pushActorAway(target, 2)
	else
		debug.sendAnimationEvent(target, "BleedOutStart")
	endIf
	if (!friendly && caster.isDetectedBy(target))
		bool naked = !(target.wornHasKeyword(ArmorCuirass) || target.wornHasKeyword(ClothingBody))
		RapeSpell.sendAlarm(target, caster, naked)
		reported = true
	endIf
	Utility.wait(1)
	; Attempt to register the targeted actor into our Slots array on the other script.
	RapeSpell.RegisterActor(target, caster, true)
	RapeSpell.RegisterActor(caster, caster, false)
endEvent

; Spell effect has expired
event OnEffectFinish(actor target, actor caster)
	; Check if the affected actor is slotted, and if so start the animation.
	if RapeSpell.IsSlotted(target) && RapeSpell.IsSlotted(caster)
		; The actor is indeed slotted, call TriggerSex() to start them animating.
		RapeSpell.TriggerSex()
	endIf
	bool friendly = (target.getRelationshipRank(caster) > 0)
	if (!friendly && !reported)
		bool naked = !(target.wornHasKeyword(ArmorCuirass) || target.wornHasKeyword(ClothingBody))
		RapeSpell.sendAlarm(target, caster, naked)
		reported = true
	endIf
endEvent

Function showMessage(String msg)
	if (getCasterActor() == Game.getPlayer())
		debug.notification(msg)
	endIf
endFunction
