Scriptname sslrsworldquestscript extends Quest  

Quest Property SSLRSRaperQuest auto
ReferenceAlias [] Property Pairs auto
GlobalVariable Property SSLRSRandomRate auto
GlobalVariable Property SSLRSCourtingRate auto
GlobalVariable Property SSLRSPlayerAssaultRate auto
GlobalVariable Property SSLRSRandomRateDefault auto
GlobalVariable Property SSLRSCourtingRateDefault auto
GlobalVariable Property SSLRSPlayerAssaultRateDefault auto
GlobalVariable Property SSLRSMagnitude auto

Event onInit()
	registerForSingleUpdate(10)
endEvent

Event onReset()
	registerForSingleUpdate(10)
endEvent

Event onUpdate()
	raperStart()
endEvent

int postponed = 0

Function raperStart()
	if (isRunning())
		int i = 0
		bool paired = false
		while (i < Pairs.Length && !paired)
			if (Pairs[i].getRef() && Pairs[i+1].getRef())
				paired = true
			endIf
			i += 2
		endWhile
		if (!paired || postponed >= 4)
			postponed = 0
			;debug.notification("RaperWorld: restarting...")
			SSLRSRaperQuest.stop()
			float clock = Utility.getCurrentGameTime() - (Utility.getCurrentGameTime() as int)
			float clockMag = math.pow(math.cos(180*(clock+1/12)), 4)*SSLRSMagnitude.getValue()
			SSLRSRandomRate.setValue(SSLRSRandomRateDefault.getValue()*clockMag)
			SSLRSCourtingRate.setValue(SSLRSCourtingRateDefault.getValue()*clockMag)
			SSLRSPlayerAssaultRate.setValue(SSLRSPlayerAssaultRateDefault.getValue()*clockMag)
			if (clockMag != 0.0)
				SSLRSRaperQuest.start()
			endIf
		else
			postponed += 1
		endIf
		registerForSingleUpdate(30)
	endIf
endFunction
